---

# EMULSION (Epidemiological Multi-Level Simulation framework)
# ===========================================================
# 
# Contributors and contact:
# -------------------------
# 
#     - Sébastien Picault (sebastien.picault@inrae.fr)
#     - Yu-Lin Huang
#     - Vianney Sicard
#     - Sandie Arnoux
#     - Gaël Beaunée
#     - Pauline Ezanno (pauline.ezanno@inrae.fr)
# 
#     INRAE, Oniris, BIOEPAR, 44300, Nantes, France
# 
# 
# How to cite:
# ------------
# 
#     S. Picault, Y.-L. Huang, V. Sicard, S. Arnoux, G. Beaunée,
#     P. Ezanno (2019). "EMULSION: Transparent and flexible multiscale
#     stochastic models in human, animal and plant epidemiology", PLoS
#     Computational Biology 15(9): e1007342. DOI:
#     10.1371/journal.pcbi.1007342
# 
# 
# License:
# --------
# 
#     Copyright 2016 INRAE and Univ. Lille
# 
#     Inter Deposit Digital Number: IDDN.FR.001.280043.000.R.P.2018.000.10000
# 
#     Agence pour la Protection des Programmes,
#     54 rue de Paradis, 75010 Paris, France
# 
#     Licensed under the Apache License, Version 2.0 (the "License");
#     you may not use this file except in compliance with the License.
#     You may obtain a copy of the License at
# 
#         http://www.apache.org/licenses/LICENSE-2.0
# 
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS,
#     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#     See the License for the specific language governing permissions and
#     limitations under the License.

#  __  __           _      _
# |  \/  |         | |    | |
# | \  / | ___   __| | ___| |
# | |\/| |/ _ \ / _` |/ _ \ |
# | |  | | (_) | (_| |  __/ |
# |_|  |_|\___/ \__,_|\___|_|
#
#  _____        __                           _   _
# |_   _|      / _|                         | | (_)
#   | |  _ __ | |_ ___  _ __ _ __ ___   __ _| |_ _  ___  _ __
#   | | | '_ \|  _/ _ \| '__| '_ ` _ \ / _` | __| |/ _ \| '_ \
#  _| |_| | | | || (_) | |  | | | | | | (_| | |_| | (_) | | | |
# |_____|_| |_|_| \___/|_|  |_| |_| |_|\__,_|\__|_|\___/|_| |_|


# NAME OF THE MODEL
model_name: compart_SIR_cumul_inc


# DESCRIPTION OF THE MODEL
model_info:
  abstract: 'This model is a simple discrete-time, stochastic,
  compartment-based SIR model. It records the cumulative incidence
  (total number of individuals that got infectious over time).
  '
  author: 'Sebastien Picault (sebastien.picault@inra.fr)'


#  _______ _
# |__   __(_)
#    | |   _ _ __ ___   ___
#    | |  | | '_ ` _ \ / _ \
#    | |  | | | | | | |  __/
#    |_|  |_|_| |_| |_|\___|

# TIME INFORMATION
# This section defines the time unit (used e.g. for expressing
# durations, rates, etc.), the duration of the time step, the origin
# date and total duration of the simulation.
time_info:
  time_unit: 'days'
  delta_t: 1
  origin: 'January 1'
  total_duration: '100'


#  _                    _
# | |                  | |
# | |     _____   _____| |___
# | |    / _ \ \ / / _ \ / __|
# | |___|  __/\ V /  __/ \__ \
# |______\___| \_/ \___|_|___/

# ORGANIZATION LEVELS USED IN THE SIMULATION
# A compartment-based model considers the population level only
levels:
  # name of the level (arbitrary name)
  population:
    desc: 'level of the population'
    aggregation_type: 'compartment'


#  _____
# |  __ \
# | |__) | __ ___   ___ ___  ___ ___  ___  ___
# |  ___/ '__/ _ \ / __/ _ \/ __/ __|/ _ \/ __|
# | |   | | | (_) | (_|  __/\__ \__ \  __/\__ \
# |_|   |_|  \___/ \___\___||___/___/\___||___/

# LIST OF PROCESSES (IN ORDER) TO BE EXECUTED DURING EACH TIME STEP
# In a Compartment-Based Model, processes take place at the population
# level and are managed by groupings
processes:
  population:
    - infection                 # name of a grouping at population level


#   _____                       _
#  / ____|                     (_)
# | |  __ _ __ ___  _   _ _ __  _ _ __   __ _
# | | |_ | '__/ _ \| | | | '_ \| | '_ \ / _` |
# | |__| | | | (_) | |_| | |_) | | | | | (_| |
#  \_____|_|  \___/ \__,_| .__/|_|_| |_|\__, |
#                        | |             __/ |
#                        |_|            |___/

# DESCRIPTION OF GROUPINGS, ASSOCIATED WITH PROCESSES WHICH ARE NOT
# DIRECTLY BASED ON STATE MACHINES
# A grouping is based on one or more variables. For instance, the
# grouping for managing the 'infection' process is based on the
# variable 'health_state' (coming from the state machine with the same
# name): hence, one group will be defined for all possible values of
# the health_state variable.

grouping:
  population:
    infection:
      machine_name: health_state
      key_variables: [health_state]


#   _____ _        _         __  __            _     _
#  / ____| |      | |       |  \/  |          | |   (_)
# | (___ | |_ __ _| |_ ___  | \  / | __ _  ___| |__  _ _ __   ___  ___
#  \___ \| __/ _` | __/ _ \ | |\/| |/ _` |/ __| '_ \| | '_ \ / _ \/ __|
#  ____) | || (_| | ||  __/ | |  | | (_| | (__| | | | | | | |  __/\__ \
# |_____/ \__\__,_|\__\___| |_|  |_|\__,_|\___|_| |_|_|_| |_|\___||___/

# DESCRIPTION OF THE STATE MACHINES INVOLVED IN THE MODEL
# Each state machine is composed at least of several states.
# The name of a state machine defines an individual variable which
# contains the value of the current state in the individual.
# Transitions define how each change can change to another one.
# Productions define how individuals in one state can produce
# new individuals in another state.
state_machines:
  # Below, the definition of the state machine used by the process
  # 'infection'
  health_state:
    desc: 'The state machine which defines the evolution of health
    states
    '
    # Below, the list of states with their attributes.
    states:
      - S:
          name: 'Susceptible'
          desc: 'suceptible of becoming infected'
          fillcolor: 'wheat'
      - I:
          name: 'Infectious'
          desc: 'infected and able to transmit the disease'
          fillcolor: 'maroon'
          on_enter:
            - record_change: cumulative_incidence
      - R:
          name: 'Resistant'
          desc: 'healthy again and resistant to infection'
          fillcolor: 'deepskyblue'
    # Below, a list of transitions between states, with rate or
    # probabilities. Rates are automatically converted into
    # probabilities w.r.t the duration of the time step (delta_t),
    # assuming a classical exponential distribution of durations in
    # the states.
    transitions:
      - {from: S, to: I, rate: 'force_of_infection'}
      - {from: I, to: R, rate: 'recovery'}


#  _____                               _
# |  __ \                             | |
# | |__) |_ _ _ __ __ _ _ __ ___   ___| |_ ___ _ __ ___
# |  ___/ _` | '__/ _` | '_ ` _ \ / _ \ __/ _ \ '__/ __|
# | |  | (_| | | | (_| | | | | | |  __/ ||  __/ |  \__ \
# |_|   \__,_|_|  \__,_|_| |_| |_|\___|\__\___|_|  |___/

# PARAMETERS/FUNCTIONS/EXPRESSIONS USED IN THE MODEL
parameters:
  initial_population_size:
    desc: 'initial number of individuals in the population'
    value: 100
  initial_infected:
    desc: 'initial number of infectious individuals in the population'
    value: 1
  transmission_I:
    desc: 'transmission rate from infectious individuals (/day)'
    value: 0.5
  recovery:
    desc: 'recovery rate (/day)'
    value: 0.1
  force_of_infection:
    desc: 'infection function'
    value: 'transmission_I * total_I / total_population'
    source: 'classical function assuming frequency dependence'
  percentage_prevalence:
    desc: 'proportion of infected+infectious individuals (%)'
    value: '100 * total_I / total_population'


#  _____           _        _
# |  __ \         | |      | |
# | |__) | __ ___ | |_ ___ | |_ _   _ _ __   ___  ___
# |  ___/ '__/ _ \| __/ _ \| __| | | | '_ \ / _ \/ __|
# | |   | | | (_) | || (_) | |_| |_| | |_) |  __/\__ \
# |_|   |_|  \___/ \__\___/ \__|\__, | .__/ \___||___/
#                                __/ | |
#                               |___/|_|

# NOT USED IN COMPARTMENT-BASED MODELS


#  _____       _ _   _       _
# |_   _|     (_) | (_)     | |
#   | |  _ __  _| |_ _  __ _| |
#   | | | '_ \| | __| |/ _` | |
#  _| |_| | | | | |_| | (_| | |
# |_____|_| |_|_|\__|_|\__,_|_|

#   _____                _ _ _   _
#  / ____|              | (_) | (_)
# | |     ___  _ __   __| |_| |_ _  ___  _ __  ___
# | |    / _ \| '_ \ / _` | | __| |/ _ \| '_ \/ __|
# | |___| (_) | | | | (_| | | |_| | (_) | | | \__ \
#  \_____\___/|_| |_|\__,_|_|\__|_|\___/|_| |_|___/

# INITIAL CONDITIONS FOR THE SIMULATION
# In compartment-based models, initial conditions describe the amount
# of population in each state
initial_conditions:
  population:
    - population:
        - total: 'initial_population_size'
        - vars: [S]
          amount: 'initial_population_size - initial_infected'
        - vars: [I]
          amount: 'initial_infected'


#   ____        _               _
#  / __ \      | |             | |
# | |  | |_   _| |_ _ __  _   _| |_ ___
# | |  | | | | | __| '_ \| | | | __/ __|
# | |__| | |_| | |_| |_) | |_| | |_\__ \
#  \____/ \__,_|\__| .__/ \__,_|\__|___/
#                  | |
#                  |_|

# TYPE AND PERIODICITY OF OUTPUTS
# The amount of individuals in each state is automatically recorded
# for all state machines each time step during the simulation.
# Additional variables (e.g. expressions defined in the 'parameters'
# section) can be specified below (as 'extra_vars').
outputs:
  type: csv
  population:
    period: 1
    extra_vars:
      - percentage_prevalence
      - total_population
      - cumulative_incidence
...
